#include <node_api.h>
#include <iostream>
#include <stdlib.h>
#include <limits.h>
#include <cstdlib>
#include <cstring>
#include "./common.h"

using namespace std;

char baseCode[] = "0123456789abcdefg";
int getBaseIndex(char ca)
{
  if (ca - 'a' >= 0)
  {
    return ca - 'a' + 10;
  }
  else
  {
    return ca - '0';
  }
}

long long converStringToLongLong(char *str, int base)
{
  long long ret;
  char *ptr;
  if (base == 10)
  {
    ret = strtoll(str, &ptr, base);
    return ret;
  }
  if ((str[0] > baseCode[(base - 1) / 2] && base != 10) || str[0] == '-')
  {
    // size_t length = strlen(str);
    char result[65];

    strcpy(result, str);
    result[0] = baseCode[getBaseIndex(result[0]) - base / 2];
    long long test = LLONG_MIN;
    ret = strtoll(result, &ptr, base);
    ret = ret | test;
    return ret;
  }
  else
  {
    ret = strtoll(str, &ptr, base);
    return ret;
  }
}
int signedHexToDec2(char *source, char *result)
{
  long long i64 = converStringToLongLong(source, 16);
  sprintf(result, "%lld", i64);
  return 0;
}
int signedDecToHex2(char *source, char *result)
{
  long long i64 = converStringToLongLong(source, 10);
  sprintf(result, "%llx", i64);
  return 0;
}

napi_value signedHexToDec(napi_env env, napi_callback_info info)
{
  size_t argc = 1;
  napi_value args[1];
  NAPI_CALL(env, napi_get_cb_info(env, info, &argc, args, NULL, NULL));

  // NAPI_ASSERT(env, argc >= 2, "Wrong number of arguments");

  napi_valuetype valuetype0;
  NAPI_CALL(env, napi_typeof(env, args[0], &valuetype0));

  // napi_valuetype valuetype1;
  // NAPI_CALL(env, napi_typeof(env, args[1], &valuetype1));

  // NAPI_ASSERT(env, valuetype0 == napi_number && valuetype1 == napi_number,
  //     "Wrong argument type. Numbers expected.");
  size_t len;
  NAPI_CALL(env, napi_get_value_string_utf8(env, args[0], NULL, 0, &len));
  char buf[65];
  size_t lenRes;
  NAPI_CALL(env, napi_get_value_string_utf8(env, args[0], buf, len + 1, &lenRes));
  char result[65];
  signedHexToDec2(buf, result);
  napi_value res;
  NAPI_CALL(env, napi_create_string_utf8(env, result, strlen(result), &res));
  return res;
}
napi_value signedDecToHex(napi_env env, napi_callback_info info)
{
  size_t argc = 1;
  napi_value args[1];
  NAPI_CALL(env, napi_get_cb_info(env, info, &argc, args, NULL, NULL));

  // NAPI_ASSERT(env, argc >= 2, "Wrong number of arguments");

  napi_valuetype valuetype0;
  NAPI_CALL(env, napi_typeof(env, args[0], &valuetype0));

  // napi_valuetype valuetype1;
  // NAPI_CALL(env, napi_typeof(env, args[1], &valuetype1));

  // NAPI_ASSERT(env, valuetype0 == napi_number && valuetype1 == napi_number,
  //     "Wrong argument type. Numbers expected.");
  size_t len;
  NAPI_CALL(env, napi_get_value_string_utf8(env, args[0], NULL, 0, &len));
  char buf[65];
  size_t lenRes;
  NAPI_CALL(env, napi_get_value_string_utf8(env, args[0], buf, len + 1, &lenRes));
  char result[65];
  signedDecToHex2(buf, result);
  napi_value res;
  NAPI_CALL(env, napi_create_string_utf8(env, result, strlen(result), &res));
  return res;
}

napi_value Init(napi_env env, napi_value exports)
{
  napi_property_descriptor desc = DECLARE_NAPI_PROPERTY("signedHexToDec", signedHexToDec);
  napi_property_descriptor desc2 = DECLARE_NAPI_PROPERTY("signedDecToHex", signedDecToHex);
  NAPI_CALL(env, napi_define_properties(env, exports, 1, &desc));
  NAPI_CALL(env, napi_define_properties(env, exports, 1, &desc2));
  return exports;
}

NAPI_MODULE(NODE_GYP_MODULE_NAME, Init)
