'use strict'

var assert = require('assert');
var convert = require('./index');

describe('hex2decimal', function() {
	it('should work from hex to decimal', function(done) {
		// assert.equal(convert.signedHexToDec('ffffffff'), '4294967295');
		assert.equal(convert.signedHexToDec('8fffffffffffffff'), '-8070450532247928833');
		assert.equal(convert.signedHexToDec('7fffffffffffffff'), '9223372036854775807');
		assert.equal(convert.signedHexToDec('8ffffffffffffff0'), '-8070450532247928848');
		assert.equal(convert.signedHexToDec('fffffffffffffff0'), '-16');
		assert.equal(convert.signedHexToDec('ffffffffffffffff'), '-1');
		assert.equal(convert.signedHexToDec('fffff6e7b18d6000'), '-10000000000000');
		done();
	});
	it('shold work from decimal to hex', function (done) {
		assert.equal(convert.signedDecToHex('4294967295'), 'ffffffff');
		assert.equal(convert.signedDecToHex('9223372036854775807'), '7fffffffffffffff');
		assert.equal(convert.signedDecToHex('-1'), 'ffffffffffffffff');
		assert.equal(convert.signedDecToHex('-10'), 'fffffffffffffff6');
		assert.equal(convert.signedDecToHex('-10000000000000'), 'fffff6e7b18d6000');
		done();
	});
});
